let pc = undefined;
let audioCanvas = undefined;
let audioVisualizer = undefined;


//state表示状态，可选的值包括 ready,pending,publishing
let state = {

	playState: "ready",
	localStream:undefined,
	videoElementPlay: undefined
}	


$(document).ready(() => {
	
	console.log("ready");
	state.videoElementPlay = document.getElementById('subscribe-video');
	audioCanvas = document.getElementById('audioCanvas');
	
	let protocol = window.location.protocol;
	let host = window.location.hostname;
	let port = window.location.port;
	
	let base_url = protocol + "//"+ host +":"+ port +"/" ;
	if (port == "")
	{
		base_url = protocol + "//"+ host +"/" 
	}
	
	$("#url").val(base_url);
	initListener();	
	
}
);


const initListener = async() =>
{
	$("#play-toggle").click((e) => {
		
		if (state.playState == "playing"){
			clearLogs();
			stop();
			
		}else if (state.playState == "pending"){
			return;
		}
		else 
		{
			try {
			   start();				
			}
			catch(e){
			  log(e);
			}
		}
		
	}
	);
		
}


const stop = () =>{

	if (pc != null)
	{
		pc.close();
	}	

	pc = undefined;
	$("#play-toggle").text("播放");
	state.playState = "ready";
	log("connection closed");
  
}	


const start = () =>{	
	
	clearLogs();
	
	let signal_url = document.getElementById("url").value;
	if (signal_url == "")
	{
		$("#url").css("border-color","#FF0000");
		return;
	}
	$("#url").removeAttr("style");	
	
	state.playState = "pending";

	pc = new RTCPeerConnection({
        iceServers: [],
        rtcpMuxPolicy: 'require',
        bundlePolicy: 'max-bundle',
    })
    pc.oniceconnectionstatechange = e => log(pc.iceConnectionState)
    pc.onicecandidate = event => {
        if (event.candidate === null) {
            log("gather done " + JSON.stringify(pc.localDescription))
		fetch(signal_url, {	  
			    method: "POST",
                body: JSON.stringify({
                    sdp: pc.localDescription
					//direction:"pull"                    
                }),
                headers: {
                    "Content-type": "application/json; charset=UTF-8"
                }
            })
            .then((response) => response.json())
            .then((json) => {
                log("--- got response")
                log(JSON.stringify(json))
                try {
					if (json.data != undefined )
					{
						pc.setRemoteDescription(new RTCSessionDescription(json.data.sdp));
						state.playState = "playing";
						$("#play-toggle").text("停止");
					}else{
						stop();
					}
                } catch (e) {
					stop();
					log(e)
                }
            })
			.catch( (e)=>{
				stop();
				log(e);
				
			});
        }
    }
	pc.addTransceiver('video', {direction: "recvonly"})
    pc.addTransceiver('audio', {direction: "recvonly"})
  

    pc.ontrack = function (event) {
        
        state.videoElementPlay.srcObject = event.streams[0]
        state.videoElementPlay.autoplay = true;
		state.playState = "playing";
		$("#play-toggle").text("停止");
        
        audioVisualizer = new StreamVisualizer(event.streams[0], audioCanvas);
        audioVisualizer.start();
    }
	
	pc.createOffer()
      .then(d => pc.setLocalDescription(d))
      .catch(log)
	
}

const log = msg => {
    document.getElementById('logs').innerHTML += msg + '<br>'
}


const clearLogs = () => {
    $("#logs").empty();
  
}
  
